<?php
/*------------------------------------------------------------------------
 # Full Slider  - Version 1.0
 # Copyright (C) 2011- 2012 YouTech Club. All Rights Reserved.
 # @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 # Author: YouTech Club
 # Websites: http://www.youtechclub.com
 -------------------------------------------------------------------------*/
 
require_once (JPATH_SITE . '/components/com_content/helpers/route.php');

if (! class_exists("Full_Slider") ) {
class Full_Slider {
	var $items = array();
	var $featured = 2;    // 0 - without featured articles, 1 - only featured articles - 2 both    
    var $category = 0;
	var $total_articles = 5;
	var $customUrl = array();      
    var $arrCustomUrl = array();
	var $sort_order_field = 'created';
	var $large_width = '350';
	var $large_height = '350';
	var $small_width = '350';
	var $small_height = '350';
	var $web_url = '';	
	var $thumbnail_mode = 0;
	var $limit_title = 25;
	var $limit_description = 120;
	var $resize_folder = '';
	var $url_to_resize = '';
	var $url_to_module = '';	
	var $count_character_desc = 1;  
    var $cutStr_style_article = 1;
	var $target = '_blank';
	
	function Content() {
		
	}
		
	function getList($module) {
			 global $mainframe;           
            $items = array();
			$arrCustomUrl = Full_Slider::getArrURL($this->customUrl);   
			$db = & JFactory::getDBO ();
			$user = & JFactory::getUser ();
			$aid = $user->get ( 'aid', 0 );
			$aid = 1;
			$contentConfig = &JComponentHelper::getParams ( 'com_content' );
			$noauth = ! $contentConfig->get ( 'shownoauth' );			
			jimport ( 'joomla.utilities.date' );
			$date = new JDate ( );
			$now = $date->toMySQL ();			
			$nullDate = $db->getNullDate ();          
		
			if ($this->sort_order_field == 'random') {				
				$orderby =  ' ORDER BY rand()';			
			} 
			else 
			{				
				$orderby = ' ORDER BY ' . $this->sort_order_field;			
			}
			$limit = " LIMIT {$this->total_articles}";
            
            if (is_array($this->category)){
                $ary = " in (" . implode("," , $this->category) . ")";   
            } else { 
                $ary = " = ". ( int ) $this->category;     
            }
		
			// query to determine article count
			$query = 'SELECT a.*,u.name as creater,cc.description as catdesc, cc.title as cattitle,' . ' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,' . ' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug FROM #__content AS a' . ' INNER JOIN #__categories AS cc ON cc.id = a.catid' . ' left JOIN #__users AS u ON a.created_by = u.id';          
			
             $query .= ' WHERE a.state = 1 '. ($noauth ? ' AND a.access <= ' . ( int ) $aid . ' AND cc.access <= ' . ( int ) $aid : '') . ' AND (a.publish_up = ' . $db->Quote ( $nullDate ) . ' OR a.publish_up <= ' . $db->Quote ( $now ) . ' ) ' . ' AND cc.id '. $ary . ' AND (a.publish_down = ' . $db->Quote ( $nullDate ) . ' OR a.publish_down >= ' . $db->Quote ( $now ) . ' )' . ' AND cc.published = 1';
            
			if ($this->featured == 0) 
			{
				$query .= ' AND a.featured = 0';
			} 
			else if ($this->featured == 1) {
				$query .= ' AND a.featured = 1';
			}
			$query .= $orderby . $limit;            
			$db->setQuery ( $query );						
			$items = $db->loadObjectList ();
			//var_dump($items); die;
		    
			global $mainframe;
            JPluginHelper::importPlugin ( 'content' );
			$dispatcher = & JDispatcher::getInstance ();
			$params =& JComponentHelper::getParams('com_content');
            if(!empty($items)){     	
                    foreach ($items as $key=>$item) { 					
                    $temp = array();        
                    $item->introtext = trim($item->introtext);
                    $item->text = $item->introtext;
                    $item->text .= $item->fulltext;                    
                    $item->article_image = $this->getImage($item->text);
					
					if (!file_exists($item->article_image))
					{
					$item->article_image = 'modules/'.$module->module.'/images/no_image.gif';
					}
				
                    $item->large_thumb = Full_Slider::thumb_mode($item->article_image, $this->large_width, $this->large_height, $this->thumbnail_mode); 
				
				    if($item->access <= $aid ) 
					{
				     if(array_key_exists($item->id, $arrCustomUrl))
					 {
					   $item->article_link = $arrCustomUrl[$item->id];
					 }
					 else
					 {
					   if ($this->target == 'popup'){
                       $item->article_link = JRoute::_(ContentHelperRoute::getArticleRoute($item->slug, $item->catslug))."&tmpl=component";    
                        }
                        else 
                        {
                         $item->article_link = JRoute::_(ContentHelperRoute::getArticleRoute($item->slug, $item->catslug));  
                        }  
					  }
                    }
					
					$item->article_desc = $this->removeImage($item->text);
					if (!isset($item->article_title))
					{
					$item->article_title = $this->cutStr($item->title, $this->limit_title);
					}                       
				    if (!isset($item->article_content)&& ($this->count_character_desc ==1)){
					if($this->cutStr_style_article == 1){                            
					$item->article_content = KeepingHtml::mb_trim($item->article_desc, $pos = 0, $this->limit_description, $hiddenClasses = '', $encoding = 'utf-8');
					}
					else
					{
					$item->article_content = $this->cutStr($item->article_desc, $this->limit_description);
					}
					}
					if (!isset($item->article_content)&& ($this->count_character_desc ==0)){
					if($this->cutStr_style_article == 1){                            
					$item->article_content = $item->article_desc;
					}
					else
					{
					$item->article_content = strip_tags($item->article_desc);
					}
					}
						
                    $temp['article_id'] 		  = $item->id;             
					$temp['article_title']        = $item->article_title; 					
                    $temp['large_thumb']		  = $item->large_thumb;  
                    $temp['article_content']      = $item->article_content;
                    $temp['article_link']         = $item->article_link;
                    $temp['creater'] 			  = $item->creater; 

					$items[$key] = $temp;
                    }				
                    }
               
               return $items;        
            }

        
		function getImage($str){            
		$regex = "/\<img.+src\s*=\s*\"([^\"]*)\"[^\>]*\>/";
		$matches = array();
		preg_match ( $regex, $str , $matches );    
		$images = (count($matches)) ? $matches : array ();
		$image = count($images) > 1 ? $images[1] : '';
					
		return $image;
		}
            
        function removeImage($str) {
        $regex1 = "/\<img[^\>]*>/";
        $str = preg_replace ( $regex1, '', $str );
        $regex1 = "/<div class=\"mosimage\".*<\/div>/";
        $str = preg_replace ( $regex1, '', $str );
        $str = trim ( $str );
        
        return $str;
            }
        function thumb_mode ($image, $image_width, $image_height, $image_mode) {    
		if (!isset($thumb) && ($image != '')) {
				$thumb = $this->processImage($image, $image_width, $image_height, $image_mode);    
			}
			else {
				$thumb = '';
			}   
		return $thumb;
		}  
        
        function getArrURL($customUrl) {     
        $arrUrl = array();
        $tmp = explode("\n", trim($customUrl));            
        foreach( $tmp as $strTmp){
			$pos = strpos($strTmp, ":");
			if($pos >=0)
			{
				$tmpKey = substr($strTmp, 0, $pos);
				$key = trim($tmpKey);
				$tmpLink = substr($strTmp, $pos+1, strlen($strTmp)-$pos);
				$haveHttp =  strpos(trim($tmpLink), "http://");
				//var_dump($haveHttp);die;                   
				if($haveHttp<0 || ($haveHttp !== false) ){
					$link = trim($tmpLink);
				}else{
					$link = "http://" . trim($tmpLink);
				}
				$arrUrl[$key] = $link;
		   }  
        }            
        return $arrUrl;
        }
        
        function processImage($img, $width, $height, $thumbmode) {
        $imagSource = JPATH_SITE.DS. str_replace( '/', DS, $img );    
        
        if(file_exists($imagSource) && is_file($imagSource))
		{
    
         switch ($thumbmode)
			{
			case '0': return $this->resizeImage($img, $width, $height);
						  break;  
			case '1': return $this->cropImage($img, $width, $height);
						  break;               
			case '2': return $img; 
						  break;  			  					 
			default:  return $this->resizeImage($img, $width, $height);                             
						 break;
			}  	
		 } 
		 else
		 {    
            return '';
           }
        }     

        
    function resizeImage($imagePath, $width, $height) {
        global $module;
                
        $folderPath = $this->resize_folder;
         
         if(!JFolder::exists($folderPath)){
                 JFolder::create($folderPath);     
         }
         
         $nameImg = str_replace('/','',strrchr($imagePath,"/"));
            
         $ext = substr($nameImg, strrpos($nameImg, '.'));
        
         $file_name = substr($nameImg, 0,  strrpos($nameImg, '.'));
        
         $nameImg = $file_name . "_" . $width . "_" . $height .  $ext;
         
         
         if(!JFile::exists($folderPath.DS.$nameImg)){
             $image = new SimpleImage();
               $image->load($imagePath);
               $image->resize($width,$height);
                $image->save($folderPath.DS.$nameImg);
         }else{
                  list($info_width, $info_height) = @getimagesize($folderPath.DS.$nameImg);
                  if($width!=$info_width||$height!=$info_height){
                       $image = new SimpleImage();
                       $image->load($imagePath);
                       $image->resize($width,$height);
                        $image->save($folderPath.DS.$nameImg);
                  }
         }
            return $this->url_to_resize . $nameImg;
    }
    
    function cropImage($imagePath, $width, $height) {
        global $module;
        
        $folderPath = $this->resize_folder;
         
        if(!JFolder::exists($folderPath)){
                 JFolder::create($folderPath);     
        }
         
        $nameImg = str_replace('/','',strrchr($imagePath,"/"));         
         
         if(!JFile::exists($folderPath.DS.$nameImg)){
             $image = new SimpleImage();
               $image->load($imagePath);
               $image->crop($width,$height);
                $image->save($folderPath.DS.$nameImg);
         }else{
                  list($info_width, $info_height) = @getimagesize($folderPath.DS.$nameImg);
                  if($width!=$info_width||$height!=$info_height){
                       $image = new SimpleImage();
                       $image->load($imagePath);
                       $image->crop($width,$height);
                        $image->save($folderPath.DS.$nameImg);
                  }
         }
         
            return $this->url_to_resize . $nameImg;
    }

    /*Cut string*/
    function cutStr( $str, $number){
        //If length of string less than $number
        $str = strip_tags($str);
        if(strlen($str) <= $number){
            return $str;
        }
        $str = substr($str,0,$number);
    
        $pos = strrpos($str,' ');
    
        return substr($str,0,$pos).'...';
    }
   
}
}

if (! class_exists("SimpleImage") ) {
class SimpleImage {
   var $image;
   var $image_type;
 
   function load($filename) {
      $image_info = getimagesize($filename);
      $this->image_type = $image_info[2];
          
         
      if( $this->image_type == IMAGETYPE_JPEG ) {
         $this->image = imagecreatefromjpeg($filename);
      } elseif( $this->image_type == IMAGETYPE_GIF ) {
         $this->image = imagecreatefromgif($filename);
      } elseif( $this->image_type == IMAGETYPE_PNG ) {
         $this->image = imagecreatefrompng($filename);
      }
   }
   function save($filename, $image_type=IMAGETYPE_JPEG, $compression=75, $permissions=null) {
               
      if( $image_type == IMAGETYPE_JPEG ) {
         imagejpeg($this->image,$filename,$compression);
      } elseif( $image_type == IMAGETYPE_GIF ) {
         imagegif($this->image,$filename);         
      } elseif( $image_type == IMAGETYPE_PNG ) {
         imagepng($this->image,$filename);
      }   
      if( $permissions != null) {
         chmod($filename,$permissions);
      }
   }
   function output($image_type=IMAGETYPE_JPEG) {
      if( $image_type == IMAGETYPE_JPEG ) {
         imagejpeg($this->image);
      } elseif( $image_type == IMAGETYPE_GIF ) {
         imagegif($this->image);         
      } elseif( $image_type == IMAGETYPE_PNG ) {
         imagepng($this->image);
      }   
   }
   function getWidth() {
      return imagesx($this->image);
   }
   function getHeight() {
      return imagesy($this->image);
   }
   function resizeToHeight($height) {
      $ratio = $height / $this->getHeight();
      $width = $this->getWidth() * $ratio;
      $this->resize($width,$height);
   }
   function resizeToWidth($width) {
      $ratio = $width / $this->getWidth();
      $height = $this->getheight() * $ratio;
      $this->resize($width,$height);
   }
   function scale($scale) {
      $width = $this->getWidth() * $scale/100;
      $height = $this->getheight() * $scale/100; 
      $this->resize($width,$height);
   }
   function resize($width,$height) {
         $new_image = imagecreatetruecolor($width, $height);
      imagecopyresampled($new_image    , $this->image, 0, 0, 0, 0, $width, $height, $this->getWidth(), $this->getHeight());
      $this->image = $new_image; 
   }    
   function getbeginWidth($width){
   $k = $this->getWidth();
   $x1 = ($k - $width)/2;
   return $x1;
   }
   function getbeginHeight($height){
   $k = $this->getHeight();
   $y1 = ($k - $height)/2;
   return $y1;
   }
   function crop($width,$height) {
      $new_image = imagecreatetruecolor($width, $height);
      imagecopyresampled($new_image, $this->image, 0, 0, $this->getbeginWidth($width), $this->getbeginHeight($height),  $width, $height, $width, $height);
      $this->image = $new_image;   
   }   
}
}
/* Keeping html tag class*/
if (! class_exists ( 'KeepingHtml' )) {
	class KeepingHtml {
		/*
      $hiddenClasses: Class that have property display: none or invisible.
    */
		function mb_trim($strin, $pos = 0, $len = 10000, $hiddenClasses = '', $encoding = 'utf-8') {
			mb_internal_encoding ( $encoding );
			$strout = trim ( $strin );
			
			$pattern = '/(<[^>]*>)/';
			$arr = preg_split ( $pattern, $strout, - 1, PREG_SPLIT_DELIM_CAPTURE );
			$left = $pos;
			$length = $len;
			$strout = '';
			for($i = 0; $i < count ( $arr ); $i ++) {
				$arr [$i] = trim ( $arr [$i] );
				if ($arr [$i] == '')
					continue;
				if ($i % 2 == 0) {
					if ($left > 0) {
						$t = $arr [$i];
						$arr [$i] = mb_substr ( $t, $left );
						$left -= (mb_strlen ( $t ) - mb_strlen ( $arr [$i] ));
					}
					
					if ($left <= 0) {
						if ($length > 0) {
							$t = $arr [$i];
							$arr [$i] = mb_substr ( $t, 0, $length );
							$length -= mb_strlen ( $arr [$i] );
							if ($length <= 0) {
								$arr [$i] .= '...';
							}
						
						} else {
							$arr [$i] = '';
						}
					}
				} else {
					if (KeepingHtml::isHiddenTag ( $arr [$i], $hiddenClasses )) {
						if ($endTag = KeepingHtml::getCloseTag ( $arr, $i )) {
							while ( $i < $endTag )
								$strout .= $arr [$i ++] . "\n";
						}
					}
				}
				$strout .= $arr [$i] . "\n";
			}
			//echo $strout;  
			return KeepingHtml::toString ( $arr, $len );
		}
		
		function trim($strin, $pos = 0, $len = 10000, $hiddenClasses = '') {
			$strout = trim ( $strin );
			
			$pattern = '/(<[^>]*>)/';
			$arr = preg_split ( $pattern, $strout, - 1, PREG_SPLIT_DELIM_CAPTURE );
			$left = $pos;
			$length = $len;
			$strout = '';
			for($i = 0; $i < count ( $arr ); $i ++) {
				$arr [$i] = trim ( $arr [$i] );
				if ($arr [$i] == '')
					continue;
				if ($i % 2 == 0) {
					if ($left > 0) {
						$t = $arr [$i];
						$arr [$i] = substr ( $t, $left );
						$left -= (strlen ( $t ) - strlen ( $arr [$i] ));
					}
					
					if ($left <= 0) {
						if ($length > 0) {
							$t = $arr [$i];
							$arr [$i] = substr ( $t, 0, $length );
							$length -= strlen ( $arr [$i] );
							if ($length <= 0) {
								$arr [$i] .= '...';
							}
						
						} else {
							$arr [$i] = '';
						}
					}
				} else {
					if (KeepingHtml::isHiddenTag ( $arr [$i], $hiddenClasses )) {
						if ($endTag = KeepingHtml::getCloseTag ( $arr, $i )) {
							while ( $i < $endTag )
								$strout .= $arr [$i ++] . "\n";
						}
					}
				}
				$strout .= $arr [$i] . "\n";
			}
			//echo $strout;  
			return KeepingHtml::toString ( $arr, $len );
		}
		
		function isHiddenTag($tag, $hiddenClasses = '') {
			//By pass full tag like img
			if (substr ( $tag, - 2 ) == '/>')
				return false;
			if (in_array ( KeepingHtml::getTag ( $tag ), array ('script', 'style' ) ))
				return true;
			if (preg_match ( '/display\s*:\s*none/', $tag ))
				return true;
			if ($hiddenClasses && preg_match ( '/class\s*=[\s"\']*(' . $hiddenClasses . ')[\s"\']*/', $tag ))
				return true;
		}
		
		function getCloseTag($arr, $openidx) {
			$tag = trim ( $arr [$openidx] );
			if (! $openTag = KeepingHtml::getTag ( $tag ))
				return 0;
			
			$endTag = "<$openTag>";
			$endidx = $openidx + 1;
			$i = 1;
			while ( $endidx < count ( $arr ) ) {
				if (trim ( $arr [$endidx] ) == $endTag)
					$i --;
				if (KeepingHtml::getTag ( $arr [$endidx] ) == $openTag)
					$i ++;
				if ($i == 0)
					return $endidx;
				$endidx ++;
			}
			return 0;
		}
		
		function getTag($tag) {
			if (preg_match ( '/\A<([^\/>]*)\/>\Z/', trim ( $tag ), $matches ))
				return ''; //full tag
			if (preg_match ( '/\A<([^ \/>]*)([^>]*)>\Z/', trim ( $tag ), $matches )) {
				//echo "[".strtolower($matches[1])."]";
				return strtolower ( $matches [1] );
			}
			//if (preg_match ('/<([^ \/>]*)([^\/>]*)>/', trim($tag), $matches)) return strtolower($matches[1]);
			return '';
		}
		
		function toString($arr, $len) {
			$i = 0;
			$stack = new JAStack ( );
			$length = 0;
			while ( $i < count ( $arr ) ) {
				$tag = trim ( $arr [$i ++] );
				if ($tag == '')
					continue;
				if (KeepingHtml::isCloseTag ( $tag )) {
					if ($ltag = $stack->getLast ()) {
						if ('</' . KeepingHtml::getTag ( $ltag ) . '>' == $tag)
							$stack->pop ();
						else
							$stack->push ( $tag );
					}
				} else if (KeepingHtml::isOpenTag ( $tag )) {
					$stack->push ( $tag );
				} else if (KeepingHtml::isFullTag ( $tag )) {
					//echo "[TAG: $tag, $length, $len]\n";
					if ($length < $len)
						$stack->push ( $tag );
				} else {
					$length += strlen ( $tag );
					$stack->push ( $tag );
				}
			}
			
			return $stack->toString ();
		}
		
		function isOpenTag($tag) {
			if (preg_match ( '/\A<([^\/>]+)\/>\Z/', trim ( $tag ), $matches ))
				return false; //full tag
			if (preg_match ( '/\A<([^ \/>]+)([^>]*)>\Z/', trim ( $tag ), $matches ))
				return true;
			return false;
		}
		
		function isFullTag($tag) {
			//echo "[Check full: $tag]\n";
			if (preg_match ( '/\A<([^\/>]*)\/>\Z/', trim ( $tag ), $matches ))
				return true; //full tag
			return false;
		}
		
		function isCloseTag($tag) {
			if (preg_match ( '/<\/(.*)>/', $tag ))
				return true;
			return false;
		}
	}
	
	class JAStack {
		var $_arr = null;
		function JAStack() {
			$this->_arr = array ();
		}
		
		function push($item) {
			$this->_arr [count ( $this->_arr )] = $item;
		}
		function pop() {
			if (! $c = count ( $this->_arr ))
				return null;
			$ret = $this->_arr [$c - 1];
			unset ( $this->_arr [$c - 1] );
			return $ret;
		}
		function getLast() {
			if (! $c = count ( $this->_arr ))
				return null;
			return $this->_arr [$c - 1];
		}
		function toString() {
			$output = '';
			foreach ( $this->_arr as $item ) {
				$output .= $item . "\n";
			}
			return $output;
		}
	}
}

?>