<?php
/*------------------------------------------------------------------------
 # Full Slider  - Version 1.0
 # Copyright (C) 2011- 2012 YouTech Club. All Rights Reserved.
 # @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 # Author: YouTech Club
 # Websites: http://www.youtechclub.com
 -------------------------------------------------------------------------*/

defined( '_JEXEC' ) or die( 'Restricted access' );

require_once (dirname(__FILE__).DS.'helper.php');

jimport("joomla.filesystem.folder");
jimport("joomla.filesystem.file");

/*-- Process---*/
$note 							= $params->get("note", 0);
$target 						= $params->get("target", '_blank');
$jquery 						= $params->get("jquery", 0);
$pauseOnHover 					= $params->get("pauseOnHover", 'true');
$stopOnHover 					= $params->get("stopOnHover", 'false');
$theme 							= $params->get('layout', 'default');
$slideshow_speed 				= $params->get("slideshow_speed", 800);
$timer_speed 					= $params->get("timer_speed", 3000);
$caption_background 			= $params->get("caption_background", '#000000');
$background_module 				= $params->get("background_module", '#ffffff');
$title_color 					= $params->get("title_color", '#FFFFFF');
$left_right_button 				= $params->get("left_right_button", 1);
$large_height 					= $params->get('large_height', "450");
$large_width 					= $params->get('large_width', "230");	
$small_height 					= $params->get('small_height', "225");
$small_width 					= $params->get('small_width', "115");		
$show_description 				= $params->get('show_description', 1);
$description_color 				= $params->get('description_color', "#EEEEEE");
$color_total_tag 				= $params->get('color_total_tag', "#666666");
$link_caption					= $params->get('link_caption', 1);
$link_image						= $params->get('link_image', 1);
$auto_play						= $params->get('auto_play', 1);
$sort_order_field               = $params->get("sort_order_field",'created');  
$category                       = $params->get('category',0); 
$customUrl                      = $params->get('customUrl', 0); 
$introtext 						= $params->get("introtext", '');
$footertext   					= $params->get("footertext", '');   
$cutStr_style_article           = $params->get('cutStr_style_article', 1);  
$count_character_desc           = $params->get('count_character_desc', 1);  
$width_module                   = $params->get('width_module', 960);    
$show_title                     = $params->get('show_title', 1);
$show_total_button              = $params->get('show_total_button', 1);  
$show_number_button             = $params->get('show_number_button', 1); 
$show_title_desc            	= $params->get('show_title_desc', 1);  
$limit_description              = $params->get('limit_description', 120);
$limit_title             		= $params->get('limit_title', 25);
$total_articles 				= $params->get('total_articles', 5);
$start_slide					= intval($params->get('start_slide', 1));
$effect		      				= $params->get('effect', 'swing');
$thumbnail_mode					= $params->get('thumbnail_mode', 0);	


$browser = new Browser();

if (!defined ('FULL_SLIDER')) 
{
	define ('FULL_SLIDER', 1);
	
	if (!defined ('YTCJQUERY')){
		define('YTCJQUERY', 1);
		JHTML::script('ytc.jquery-1.5.min.js', JURI::base() . '/modules/'.$module->module.'/assets/js/');				
	}
	if($jquery){
	JHTML::script('jquery.fullslider.js',JURI::base() . '/modules/'.$module->module.'/assets/js/');	
	}
	JHTML::stylesheet('style.css', JURI::base() . '/modules/'.$module->module.'/assets/');			
}
$full_slider = new modFullSliderHelper();
$items = $full_slider->process($params, $module);
$count_items = count($items);

//Check $start_slide is greater than $count_items
if($start_slide > $count_items){
	$start_slide = $count_items;
}
if($start_slide <1){
	$start_slide = 1;
}
//Check $auto_play is greater than '0', time in milliseconds the carousel will wait before automatically rotating.
if($auto_play > 0) {
$auto_play = $timer_speed;
}

$path = JModuleHelper::getLayoutPath( 'mod_fullslider', $theme );
if (file_exists($path)) {
	require($path);
}
?>
