<?php 
/*------------------------------------------------------------------------
 # Full Slider  - Version 1.0
 # Copyright (C) 2011- 2012 YouTech Club. All Rights Reserved.
 # @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 # Author: YouTech Club
 # Websites: http://www.youtechclub.com
 -------------------------------------------------------------------------*/
?>
<?php defined( '_JEXEC' ) or die( 'Restricted access' ); 
JHTML::_('behavior.modal');  
?>
 <script type="text/javascript">
      $jYtc(document).ready(function() {
        $jYtc("#carousel_<?php echo $module->id;?>").featureCarousel({
          autoPlay: <?php echo $auto_play;?>,
		  startingFeature: <?php echo $start_slide;?>,
		  stopOnHover:<?php echo $stopOnHover;?>,
		  pauseOnHover:<?php echo $pauseOnHover;?>,
		  carouselSpeed:<?php echo $slideshow_speed;?>,
		  <?php if($thumbnail_mode !='2'){?>
   		  largeFeatureWidth :<?php echo $large_width;?>,
		  largeFeatureHeight:<?php echo $large_height;?>,
		  smallFeatureWidth :<?php echo $small_width;?>,
		  smallFeatureHeight:<?php echo $small_height;?>,
		  <?php }?>
		  animationEasing:'<?php echo $effect;?>'
        });
      });
    </script>
<style>
#yt-full-slider_<?php echo $module->id;?> .carousel{
  background:<?php echo $background_module;?>;
}
#yt-full-slider_<?php echo $module->id;?> .carousel .carousel-caption{
  background:<?php echo $caption_background;?>;
}
#yt-full-slider_<?php echo $module->id;?> .carousel .carousel-caption .article_title{
  color:<?php echo $title_color;?>;
  font-size: 16px;
  font-weight: bold
}
#yt-full-slider_<?php echo $module->id;?> .carousel .carousel-caption .article_title a{
  color:<?php echo $title_color;?>;
  font-size: 16px;
  font-weight:bold
}
#yt-full-slider_<?php echo $module->id;?> .carousel .carousel-caption .article_desc *{
  color:<?php echo $description_color;?>;
}

<?php if($show_total_button == 0){?>
#yt-full-slider_<?php echo $module->id;?> .carousel .tracker-summation-container{
  display: none!important; 
 }
<?php }?>
<?php if($show_number_button ==0){?>
#yt-full-slider_<?php echo $module->id;?> .carousel .tracker-individual-container{
  display: none!important; 
 }
<?php }?>
#yt-full-slider_<?php echo $module->id;?> .carousel .tracker-summation-container{
  background-color:<?php echo $color_total_tag;?>; 
 }
#yt-full-slider_<?php echo $module->id;?> .carousel .tracker-individual-container .tracker-individual-blip{
  background-color:<?php echo $color_total_tag;?>; 
 }
</style>

<?php if(!empty($items)):?>
<div id="yt-full-slider_<?php echo $module->id;?>" class="yt_full_slider">
<?php if($introtext): ?>
<div class="yt-introtext" style="width:<?php echo $width_module;?>px;">
<?php echo $introtext;?>
</div>
<?php endif;?>
    <div id="carousel-container" style="width:<?php echo $width_module;?>px; height:<?php echo ($large_height + 50);?>px;">
      <div id="carousel_<?php echo $module->id;?>" class="carousel" style="width:<?php echo $width_module;?>px; height:<?php echo ($large_height + 50);?>px;">
	   <?php foreach($items as $key=>$value) {?> 
        <div class="carousel-feature" style="width:<?php echo $large_width;?>px; height:<?php echo $large_height;?>px;">
		  <div class="article_image">
			  <?php if($link_image ==1){
			   if($target=='popup'){?>
			   
			  <a rel="{handler: 'iframe', size: {x: 800, y: 500}}" href="<?php echo $value['article_link'];?>" target ="<?php echo $target;?>" class="modal" style="outline: none;">
			  <?php } else {?>
			  <a href="<?php echo $value['article_link'];?>" target="<?php echo $target;?>">
			  <?php }?>
			  <img class="carousel-image" src="<?php echo $value['large_thumb']?>" href="<?php echo $value['article_link'];?>">
			  </a>
			  <?php } else{?>
			  <img class="carousel-image" src="<?php echo $value['large_thumb']?>">
			  <?php }?>
		  </div><!--end article_image-->
		  <?php if($show_title_desc ==1){?>
		  <div class="carousel-caption">
			  <div class="title_desc">
				<?php if(($show_title == 1) && ($value['article_title'] !='')){?>
				<div class="article_title">	
					<?php if($link_caption ==1){
					 if($target=='popup'){?>			   
					<a rel="{handler: 'iframe', size: {x: 800, y: 500}}" href="<?php echo $value['article_link'];?>" target ="<?php echo $target;?>" class="modal" style="outline: none;">
					<?php } else {?>
					<a href="<?php echo $value['article_link'];?>" target="<?php echo $target;?>">
					<?php }?>
					<?php echo $value['article_title'];?>	
					</a>
					<?php } else 
					{?>
					<?php echo $value['article_title']; 
					}?>		
				</div><!--end article_title-->
				<?php }?>
				<?php if($show_description == 1) {?>
				<div class="article_desc">		
					<?php echo $value['article_content'];?>
				</div><!--end article_desc-->
				<?php }?>
			  </div>
		  </div> <!--end carousel-caption-->
		  <?php }?>
        </div> <!--end carousel-feature-->
	   <?php }?>	
  
      </div> <!--end carousel-->
      <?php if($left_right_button ==1) {?>
      <div id="carousel-left">&nbsp;</div>
      <div id="carousel-right">&nbsp;</div>
	  <?php }?>
    </div>
<?php if($footertext): ?>
<div class="yt-footer" style="width:<?php echo $width_module;?>px;">
<?php echo $footertext;?>
</div>
<?php endif;?>
</div> <!--end yt_full_slider-->
<?php else: echo JText::_('Has no content to show!');?>
<?php endif;?>
