<?php 
/*------------------------------------------------------------------------
 # Full Slider  - Version 1.0
 # Copyright (C) 2011- 2012 YouTech Club. All Rights Reserved.
 # @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 # Author: YouTech Club
 # Websites: http://www.youtechclub.com
 -------------------------------------------------------------------------*/
 
 
defined('_JEXEC') or die('Restricted access');
if (! class_exists("modFullSliderHelper") ) { 
require_once (dirname(__FILE__) .DS. 'assets' .DS.'Full_Slider.php');

class modFullSliderHelper {
	var $module_name = '';
	function process($params, $module) {
		
		$enable_cache 		=   $params->get('cache',1);
		$cachetime			=   $params->get('cache_time',0);
		$this->module_name = $module->module;
		
		if($enable_cache==1) {		
			$conf =& JFactory::getConfig();
			$cache = &JFactory::getCache($module->module);
			$cache->setLifeTime( $params->get( 'cache_time', $conf->getValue( 'config.cachetime' ) * 60 ) );
			$cache->setCaching(true);
			//$cache->setCacheValidation(true);
			$items =  $cache->get( array('modFullSliderHelper', 'getList'), array($params, $module));
		} else {
			$items = modFullSliderHelper::getList($params, $module);
		}
		
		return $items;		
		
	}
	
	
	function getList ($params, $module) {	
        
        $content = new Full_Slider();
        $content->featured                          = $params->get('featured', 2);
        $content->category                          = $params->get('category',0);          
        $content->sort_order_field                  = $params->get("sort_order_field",'created');  
        $content->total_articles 					= $params->get('total_articles', 5);
        $content->type_order		  				= $params->get('sort_order', "ASC");
        $content->large_height						= $params->get('large_height', "350");
        $content->large_width 						= $params->get('large_width', "350");
        $content->small_height						= $params->get('small_height', "200");
        $content->small_width 						= $params->get('small_width', "200");
        $content->web_url 							= JURI::base();
        $content->limit_title      	   				= $params->get('limit_title',25); 
        $content->resize_folder 					= JPATH_CACHE.DS. $module->module .DS."images";
        $content->url_to_resize 					= $content->web_url . "cache/". $module->module ."/images/";
        $content->thumbnail_mode					= $params->get('thumbnail_mode', 0);		
		$content->customUrl                         = $params->get("customUrl", 0);   
        $content->cutStr_style_article           	= $params->get('cutStr_style_article', 1);  
		$content->count_character_desc           	= $params->get('count_character_desc', 1);         
		$content->limit_description                 = $params->get('limit_description', 120);
		$content->target 						    = $params->get("target", '_blank');
		
		$items = $content->getList($module);
				
		return $items;
	}
}
			
} 
if(!class_exists('Browser')){
	class Browser
	{
		private $props    = array("Version" => "0.0.0",
									"Name" => "unknown",
									"Agent" => "unknown") ;
	
		public function __Construct()
		{
			$browsers = array("firefox", "msie", "opera", "chrome", "safari",
								"mozilla", "seamonkey",    "konqueror", "netscape",
								"gecko", "navigator", "mosaic", "lynx", "amaya",
								"omniweb", "avant", "camino", "flock", "aol");
	
			$this->Agent = strtolower($_SERVER['HTTP_USER_AGENT']);
			foreach($browsers as $browser)
			{
				if (preg_match("#($browser)[/ ]?([0-9.]*)#", $this->Agent, $match))
				{
					$this->Name = $match[1] ;
					$this->Version = $match[2] ;
					break ;
				}
			}
		}
	
		public function __Get($name)
		{
			if (!array_key_exists($name, $this->props))
			{
				die("No such property or function {$name}");
			}
			return $this->props[$name] ;
		}
	
		public function __Set($name, $val)
		{
			if (!array_key_exists($name, $this->props))
			{
				SimpleError("No such property or function.", "Failed to set $name", $this->props);
				die;
			}
			$this->props[$name] = $val ;
		}
	
	} 
}	
?>

